import { onErrorCaptured, ref } from "./vue.esm-browser";

export default {
  name: "SuspenseWithErrors",
  setup() {
    const error = ref(null);

    onErrorCaptured((err: Error) => (error.value = err));

    return {
      error
    };
  },
  template: `
    <slot name="error" :error="error" v-if="error" />
    <Suspense v-else>
      <template #default>
        <slot name="default" />
      </template>
      <template #fallback>
        <slot name="fallback" />
      </template>
    </Suspense>
  `
};
