import { createApp, ref } from "./vue.esm-browser";
import CovidByCountry from "./CovidByCountry";

const App = {
  components: {
    "covid-by-country": CovidByCountry
  },
  setup() {
    const timeout = ref(4000);

    return {
      timeout
    };
  },
  template: `
    <h1>COVID-19 Dashboard</h1>
    <div class="app">
      <h3>Data by Country</h3>
      <Suspense>
        <template #default>
          <covid-by-country :timeout="timeout" />
        </template>
        <template #fallback>
          <div class="space-up">
            Loading please wait ...
          </div>
        </template>
      </Suspense>
    </div>
  `
};

createApp(App).mount("#app");
