import { createApp, ref } from "./vue.esm-browser";
import CovidByCountry from "./CovidByCountry";
import SuspenseWithErrors from "./SuspenseWithErrors";

const App = {
  components: {
    "covid-by-country": CovidByCountry,
    SuspenseWithErrors
  },
  setup() {
    const timeout = ref(4000);

    return {
      timeout
    };
  },
  template: `
    <h1>COVID-19 Dashboard</h1>
    <div class="app">
      <h3>Data by Country</h3>
      <SuspenseWithErrors>
        <template #error="props">
          <p class="center error space-up">
           {{ props.error }}
          </p>
        </template>
        <template #default>
          <covid-by-country :timeout="timeout" />
        </template>
        <template #fallback>
          <div class="space-up">
            Loading please wait ...
          </div>
        </template>
      </Suspense>
    </div>
  `
};

createApp(App).mount("#app");
