import { createApp, ref } from "./vue.esm-browser";

const SampleOne = {
  name: "Sample One",
  async setup() {
    const data = ref(null);

    data.value = await fetchData();

    return {
      data
    };
  },
  template: `
    <pre>{{ data }}</pre>
  `
};

const App = {
  components: {
    SampleOne
  },
  template: `
    <h1>Vue 3 Suspense</h1>
    <div class="app">
      <h3>Async/Promise with Success</h3>
      <Suspense>
        <template #default>
          <SampleOne />
        </template>
        <template #fallback>
          <div style="text-align: center; padding-top: 20px;">
            Loading please wait ...
          </div>
        </template>
      </Suspense>
    </div>
  `
};

createApp(App).mount("#app");

// Utils

async function fetchData() {
  return new Promise(async (resolve) => {
    const res = await fetch(
      `https://disease.sh/v3/covid-19/countries/?yesterday=true&strict=true`
    );
    setTimeout(async () => resolve(await res.json()), 2000);
  });
}
